/*******************************
* KM-40 web written by Katsumi *
*   This script is released    *
*     under the LGPL v2.1.     *
*******************************/

function clickStep(){
	if (cpu.step) {
		doStep();
	} else {
		cpu.step=1;
	}
}
function clickCont(){
	if (cpu.step) {
		cpu.step=0;
		start();
	}
}
function clickStopAt(val){
	if (val) {
		cpu.breakPoint=parseInt(val,16);
		if (cpu.step) {
			cpu.step=0;
			start();
		}
	}
}
function clickLogTo(val){
	if (val) {
		logto=parseInt(val,16);
		clickStep();
	} else {
		logto=0;
	}
}
function clickDump(val){
	if (val) {
		dump(parseInt(val,16));
	}
}

var log="";
var logto=0;
//cpu.breakPoint=0x09db;
function debug(str){
	dom.debug(str);
	log+=str+"\r\n";
	log=log.substr(-1000,1000);
}
function debugDisplay(addr,data){
	var str="";
	str+=(addr.toString(16)+" "+("0"+data.toString(16)).substr(-2,2)).toUpperCase()+" ";
	str+="("+("000"+cpu.regPC.toString(16)).substr(-4,4).toUpperCase()+") ";
	str+=new Date().getMilliseconds();
	str+="\r\n";
	str=str.substr(-200,200);
	if (200==str.length) {
		str=str.substr(str.indexOf("\n")+1);
	}
	dom.displaylog(str);
}
function showRegisters(){
	var str="";
	str+="PC:"+("000"+cpu.regPC.toString(16)).substr(-4,4).toUpperCase()+" ";
	str+="SP:"+("000"+(0xfc0|cpu.regSP).toString(16)).substr(-4,4).toUpperCase()+" ";
	str+="A:"+cpu.regA.toString(16).toUpperCase()+" ";
	str+="B:"+cpu.regB.toString(16).toUpperCase()+" ";
	str+="C:"+cpu.regC.toString(16).toUpperCase()+" ";
	str+="H:"+cpu.regH.toString(16).toUpperCase()+" ";
	str+="L:"+cpu.regL.toString(16).toUpperCase()+" ";
	str+="S:"+cpu.regS.toString(16).toUpperCase()+"<br />\r\n";
	str+="--ZC:00"+((cpu.regF>>1)&1)+(cpu.regF&1)+"<br />\r\n";
	if (this.prevstr) {
		var str2="";
		for (i=str.length-1;0<=i;i--) {
			if (this.prevstr.charAt(i)==str.charAt(i)) {
				str2=str.charAt(i)+str2;
			} else {
				str2="<b>"+str.charAt(i)+"</b>"+str2;
			}
		}
		this.prevstr=str;
		str=str2;
	} else {
		this.prevstr=str;
	}
	if (this.prevcode) str+="(done:"+this.prevcode+") ";
	str+=this.prevcode=disasm1(cpu.regPC,cpu.regS);
	debug(str);
}
function dump(from){
	var str="";
	var addr,data;
	for (addr=from;addr<from+64;addr+=2) {
		if ((addr&0xf)==0 || str=="") str+=("000"+addr.toString(16).toUpperCase()).substr(-4,4);
		data=(memory.read(addr)<<4)|memory.read(addr+1);
		str+=" "+("0"+data.toString(16)).substr(-2,2).toUpperCase();
		if ((addr&0xe)==0xe) str+="\r\n";
	}
	dom.dump(str);
}
function doStep(){
	if (logto) {
		var log="";
		do {
			cpu.exec(1);
			log+=cpu.regPC.toString(16)+" "+disasm1(cpu.regPC)+"\r\n";
		} while (cpu.regPC!=logto);
		dom.displaylog(log);
		logto=0;
	} else {
		cpu.exec(1);
	}
	showRegisters();
	dump(cpu.regPC);
}
function disasm1(addr,regS){
	var code=(memory.read(addr)<<4)|memory.read(addr+1);
	var scode=("0"+code.toString(16)).substr(-2).toUpperCase();
	var mnemonic=km40cpu.mnemonic[code];
	return mnemonic;
}
