/*******************************
* KM-40 web written by Katsumi *
*   This script is released    *
*     under the LGPL v2.1.     *
*******************************/

file=new Object();
file.data=[0x00,0x08];
file.browse=function(obj){
	// This will be called when a file is uploaded.
	try {
		// If FileReader API is not supported, following code will fail.
		var fr = new FileReader();
		fr.onload = function () {
			var data=new Uint8Array(fr.result);
			file.update(data);
		};
		fr.readAsArrayBuffer(obj.files[0]);
	} catch (e) {
		alert(e);
	}
};
file.update=function(data){
	this.data=data;
};
file.load=function(){
	// This will be called when a file is sucessfully loaded by FileReader API.
	var addr,endaddr,i;
	var data=this.data;
	// First 2 bytes contain starting address.
	addr=data[0]|(data[1]<<8);
	memory.write(0x0fe8,0);
	memory.write(0x0fe9,data[1]&0x0f);
	memory.write(0x0fea,data[0]>>4);
	memory.write(0x0feb,data[0]&0x0f);
	// Remaining area contains binary code.
	for (i=2;i<data.length;i++) {
		memory.write(addr++,data[i]>>4);
		memory.write(addr++,data[i]&0x0f);
	}
	addr--;
	memory.write(0x0fec,addr>>12);
	memory.write(0x0fed,(addr>>8)&0x0f);
	memory.write(0x0fee,(addr>>4)&0x0f);
	memory.write(0x0fef,addr&0x0f);
};
file.store=function(){
	var addr,endaddr,data,result,addfunc;
	addr=memory.read(0x0fe9)<<8;
	addr|=memory.read(0x0fea)<<4;
	addr|=memory.read(0x0feb);
	endaddr=memory.read(0x0fed)<<8;
	endaddr|=memory.read(0x0fee)<<4;
	endaddr|=memory.read(0x0fef);
	if (endaddr<addr) return;
	addfunc=function(data){
		if (data<16) return "%0"+data.toString(16);
		else return "%"+data.toString(16);
	};
	result=addfunc(addr&0xff);
	result+=addfunc(addr>>8);
	while(addr<=endaddr){
		data=memory.read(addr++)<<4;
		data|=memory.read(addr++);
		result+=addfunc(data);
	}
	// Create a link to save file in window.
	var filelink=dom.getElement('save');
	filelink.href="data:application/octet-stream,"+result;
	filelink.click();
};
// Web strage setting
if (window.localStorage) {
	file.storage=window.localStorage;
} else {
	file.storage=new Object();
	file.storage.getItem=function(key){
		var c=";"+document.cookie+";";
		var re=c.match(new RegExp(";[\\s]*"+key+"=([^;]?);"));
		if (re) return unescape(re[1]);
		else return "";
	};
	file.storage.setItem=function(key,value){
		document.cookie=key+"="+escape(value);
	};
}
