/*******************************
* KM-40 web written by Katsumi *
*   This script is released    *
*     under the LGPL v2.1.     *
*******************************/

// Choose CPU
cpu=km40cpu;
// Initialize CPU
var speed=10000; // 10 khz
dom.showSpeed(speed);
var maxspeed=speed;
cpu.setSpeed(speed);
cpu.reset();
cpu.events=function(){
	io.events();
};
// Initialize Memory
memory.program=[// Tiny test program
0x50,0x2e,0x3d,0x7c,0x38,0x50,0x1b,0x86,0x07,0x48,0x58,0x36,0x84,0x2f,0x54,0x0e,
0x59,0x16,0x5f,0x26,0x18,0x45,0x18,0x45,0x19,0x45,0x1a,0x4d,0x58,0x82
/*
(0800)
ld l,00
loop:
push l
xor a
wait:
push a
call 000c
pop a
dec a
jp nz,wait:
pop l
ld b,04
ld c,09
ld s,0f
ld h,s
ld (hl),a
inc l
inc l
ld (hl),b
inc l
ld (hl),c
dec l
jp loop:
*/
];
memory.init();
// The other initializations
if (get.debug  && typeof debugDisplay !="undefined") {
	// Show the debug buttons
	dom.showDebug();
}
if (get.clock) {
	// Over or under clock setting.
	switch (get.clock.substr(-1)) {
		case "k": case "K":
			maxspeed=speed=parseFloat(get.clock.substr(0,get.clock.length-1))*1000;
			break;
		case "m": case "M":
			maxspeed=speed=parseFloat(get.clock.substr(0,get.clock.length-1))*1000000;
			break;
		case "g": case "G":
			maxspeed=speed=parseFloat(get.clock.substr(0,get.clock.length-1))*1000000000;
			break;
		default:
			maxspeed=speed=parseInt(get.clock,10);
			break;
	}
	cpu.setSpeed(speed);
	dom.showSpeed(speed);
}
/*if (get.start) {
	// Immediate start user program from specified address.
	cpu.loadPC(parseInt(get.start,16));
	memory.write(0x83c7,0x00);
	memory.write(0x83c8,0x00);
	cpu.loadSP(0x83c7);
}//*/
// Following function will be called after initializing display.
start=function(){
	var time;
	time=new Date().getTime();
	setTimeout(function(){
			var from=time;
			var to=time=new Date().getTime();
			var msec=to-from;
			if (msec<100 && speed<maxspeed) {
				speed<<=1;
				if (maxspeed<speed) speed=maxspeed;
				cpu.setSpeed(speed);
				dom.showSpeed(speed);
			} else if (250<msec) {
				speed>>=1;
				if (speed<1) speed=1;
				cpu.setSpeed(speed);
				dom.showSpeed(speed);
			}
			cpu.exec(msec);
			if (cpu.step) {
				showRegisters();
			} else {
				setTimeout(arguments.callee,10);
			}
		},10);
};
